<!DOCTYPE html>
<html lang="ru">
<head>
	<meta charset="UTF-8">
	<title>Прототип</title>
</head>
<body>
	<script>
/*1)Создать конструктор Student для объекта студента, который принимает имя и кол-во баллов в качестве аргумента. 
Все объекты созданные этим конструктором должны иметь общий метод show, который работает так же как в предыдущем домашнем задании.*/		
function Student(name,point){
	this.name = name;
	this.point = point;
}
Student.prototype.show = function(){
	document.write('<br />Студент '+this.name+ ' набрал '+this.point+' баллов' );
}
/*2)Создать конструктор StudentList, который в качестве аргумента принимает название группы и массив формата 
studentsAndPoints из задания по массивам. Массив может отсутствовать или быть пустым. Объект, созданный этим конструктором 
должен обладать всеми функциями массива. А так же иметь метод add, 
который принимает в качестве аргументов имя и кол-во баллов, создает нового студента и добавляет его в список.*/

function StudentList(group, array){
this.groupName = group;
	if(array === undefined){
		array = [];
	}
	for(var i = 0; i < array.length; i+=2){
		this.push(new Student(array[i],array[i+1]));
	}
}

StudentList.prototype = Object.create(Array.prototype);//наследование от массива
StudentList.prototype.constructor = StudentList;
StudentList.prototype.add = function(name, point){
	this.push(new Student(name,point));
}

/*3)Создать список студентов группы «HJ-2» и сохранить его в переменной hj2*/
var studentsAndPoints = ['Алексей Петров',0, 'Ирина Овчинникова',60,'Глеб Стукалов',30,'Антон Павлович',30,'Виктория Заровская',30,'Алексей Левенец',70,'Тимур Вамуш',30,'Евгений Прочан',60,'Александр Малов',0];
var hj2 = new StudentList('HJ-2', studentsAndPoints);
		
		//Проверка
		/*document.write(hj2);
		hj2[1].show();
		function showStudents(group){
			group.forEach(function(student){
				document.write('Студент '+student.name+' набрал '+student.point+' баллов<br />' );
			});
		}
		showStudents(hj2);*/

/*4)Добавить несколько новых студентов в группу. Имена и баллы придумайте самостоятельно.*/
hj2.add('Саня Бородай', 50);
hj2.add('Владимир Никулин', 100);
hj2.add('Роса Зоревская', 80);

/*5)Создать группу «HTML-7» без студентов и сохранить его в переменной html7.
 После чего добавить в группу несколько студентов. Имена и баллы придумайте самостоятельно.*/

var html7 = new StudentList('HTML-7');
html7.add('Михаил Мирушин', 30); 
html7.add('Ярослава Сизова', 60); 
html7.add('Георгий Тимотин', 80); 
html7.add('Евгения Малышева', 60); 
html7.add('Растислав Добрушин', 50); 

/*6)Добавить спискам студентов метод show, который выводит информацию о группе в следующем виде:
Группа HTML-7 (2 студентов):
Студент Наталья Терентьева набрал 10 баллов
Студент Кирилл Васильев набрал 30 баллов*/

StudentList.prototype.show = function(){	
document.write('<br /><br />Группа: '+this.groupName+' ( '+this.length+' студентов )');
	this.forEach(function(student){
		student.show();
	});
}
html7.show();	
hj2.show();	

/*7)Перевести одного из студентов из группы «HJ-2» в группу «HTML-7»*/
 
function transitionStudent(name, group1, group2){
	group1.forEach(function(student,i){
		if(student.name == name){
		 group1.splice(i,1);
		 group2.push(student);
		}	
	});
}
transitionStudent('Ирина Овчинникова', hj2, html7);
/*html7.show();
hj2.show();*/

/*Добавить спискам студентов метод max, который возвращает студента с наибольшим баллом в этой группе. 
Изучите документацию метода valueOf в Object.prototype, и попробуйте использовать Math.max для решения этой задачи.*/
Student.prototype.valueOf = function(){
 	return this.point; 
}
StudentList.prototype.max = function(){
var maxPoint = Math.max.apply(Math, this); var maxStudent = this[0].name;
	this.forEach(function(student){
		if(student.point == maxPoint){
			maxStudent = student.name;
		}
	});
document.write('<br /><br />В группе '+this.groupName+' студент '+maxStudent+' набрал больше всех баллов ( '+maxPoint+' баллов ) <br /><br />');
}
hj2.max();
		
			
 





</script>


</body>
</html>